unit FeaturesWindow;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, cxDrive10, ExtCtrls;

type
  TFeaturesDialog = class(TForm)
    clFeatures: TCheckListBox;
    Cmd_Close: TButton;
    procedure FormCreate(Sender: TObject);
    procedure clFeaturesClickCheck(Sender: TObject);
  private
    { Private declarations }
    procedure SetupUi;
  public
    { Public declarations }
  end;

  procedure ShowDriveFeatures(Owner: TForm; Volume: String; Features: IDriveFeatures);

implementation

{$R *.dfm}

procedure TFeaturesDialog.FormCreate(Sender: TObject);
begin
  SetupUi;
end;

procedure TFeaturesDialog.SetupUi;
begin
  if Screen.Fonts.IndexOf('Tahoma') >= 0 then
    Font.Name := 'Tahoma'
  else
    Font.Name := 'Arial';
end;

procedure ShowDriveFeatures(Owner: TForm; Volume: String; Features: IDriveFeatures);
var
  Dlg: TFeaturesDialog;
begin
  Dlg := TFeaturesDialog.Create(Owner);
  with Dlg do
  try
    Caption := Format(Caption, [Volume]);
    clFeatures.Checked[0] := Features.ReadOnly.AsBoolean;
    clFeatures.Checked[1] := Features.Compressed.AsBoolean;
    clFeatures.Checked[2] := Features.CaseSensitive.AsBoolean;
    clFeatures.Checked[3] := Features.CasePreserved.AsBoolean;
    clFeatures.Checked[4] := Features.NamedStreams.AsBoolean;
    clFeatures.Checked[5] := Features.ObjectIds.AsBoolean;
    clFeatures.Checked[6] := Features.ReparsePoints.AsBoolean;
    clFeatures.Checked[7] := Features.SparseFiles.AsBoolean;
    clFeatures.Checked[8] := Features.DiskQuotas.AsBoolean;
    clFeatures.Checked[9] := Features.FileCompression.AsBoolean;
    clFeatures.Checked[10] := Features.FileEncryption.AsBoolean;
    clFeatures.Checked[11] := Features.PersistentAcl.AsBoolean;
    clFeatures.Checked[12] := Features.UnicodeOnDisk.AsBoolean;

    Dlg.ShowModal;
  finally
    Dlg.Free;
  end;
end;

procedure TFeaturesDialog.clFeaturesClickCheck(Sender: TObject);
var
  i: Integer;
begin
  // Prevent user checking items
  i := clFeatures.ItemIndex;
  if i >= 0 then
    clFeatures.Checked[i] := not clFeatures.Checked[i];
end;

end.
