unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Gauges, ComCtrls, Tabnotbk,
  EZProjectionL, EZMapImageL, EZConvertL;

type
  TForm1 = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    ComboBox1: TComboBox;
    Image2: TImage;
    Image1: TImage;
    Label9: TLabel;
    Label10: TLabel;
    Shape1: TShape;
    Memo1: TMemo;
    Shape2: TShape;
    Gauge1: TGauge;
    Label2: TLabel;
    EZMapImageL1: TEZMapImageL;
    EZProjectionL1: TEZProjectionL;
    Label1: TLabel;
    EZConvertL1: TEZConvertL;
    Image3: TImage;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure EZMapImage1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer; Lon, Lat: Double; Return: Integer);
    procedure CheckBox1Click(Sender: TObject);
    procedure EZProjection1GetInfo(Sender: TObject; MapName: String; TypeGeo, Reference: Boolean; EllipsType, MapNumber: Integer);
    procedure EZMapImage1Progress(Sender: TObject; Max, Position: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
//------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  // Get all projections except the UTM versions
  EZProjectionL1.GetProjectionList(ComboBox1.Items,false);
  ComboBox1.ItemIndex := 0;
  // Use ComboBox1Change procedure to draw the current projection
  ComboBox1Change(Sender);
end;
//------------------------------------------------------------------------------
procedure TForm1.ComboBox1Change(Sender: TObject);
var
TimeCalc : TTime;
begin
  // Get current time to get the total calculation time (see bottom of procedure).
  TimeCalc := Time;
  // Set the projection type. Number +3 to exclude the UTM maps
  EZProjectionL1.SetMapProjection(ComboBox1.ItemIndex + 3);
  // Sets default values. Intended for demo's
  EZMapImageL1.SetDemo;
  // If you want to oblate the map. Just try 45.
  EZProjectionL1.SetPrOblique(0);
  // Draw ColorMap and Grid. If 'Coast.dat' has been inclueded in the EXE folder and DrawCoast has been set to true, coastlines will be drawn (will take a second).
  EZMapImageL1.DrawAll;
//  EZMapImageL1.DrawGrid(180,-180,90,-90,30,0.5,false);
  // Display total calculation time.
  Label2.Caption := FloatToStr(Round((Time - TimeCalc)*24*3600*1000)) + 'ms';

end;
//------------------------------------------------------------------------------
procedure TForm1.EZMapImage1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer; Lon, Lat: Double; Return: Integer);
begin
  // Return wil be zero ('OK') if computation can be made. Will return Error (Return>0) if not.
  if Return = 0 then Label1.Caption := 'Lon: ' + FormatFloat('0.00',Lon) + '' + ' Lat: ' + FormatFloat('0.00',Lat) + ''
  else Label1.Caption := 'Error code: '+IntToStr(Return);
end;
//------------------------------------------------------------------------------
procedure TForm1.CheckBox1Click(Sender: TObject);
begin

end;
//------------------------------------------------------------------------------
procedure TForm1.EZProjection1GetInfo(Sender: TObject; MapName: String; TypeGeo, Reference: Boolean; EllipsType,MapNumber: Integer);
begin
 // Event after calling EZZProjection1.GetInfo.
 // Provides some information (just a gadget)
 MessageDlg(MapName, mtInformation,[mbOk], 0);
end;
//------------------------------------------------------------------------------
procedure TForm1.EZMapImage1Progress(Sender: TObject; Max, Position: Integer);
begin
// Gets calculation-process
Gauge1.MaxValue := Max;
Gauge1.Progress := Position;
end;
//------------------------------------------------------------------------------

end.
