unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls,Math, Tabnotbk, ExtDlgs, Gauges,EZMapValuesL,
  EZMapImageL, EZProjectionL, EZConvertL, EZCoarsL, EZConstL;

type
  TForm1 = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    TrackBar2: TTrackBar;
    TrackBar1: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    Label8: TLabel;
    Image1: TImage;
    Shape1: TShape;
    Image2: TImage;
    Label9: TLabel;
    Label10: TLabel;
    Shape2: TShape;
    Memo1: TMemo;
    Label12: TLabel;
    Image3: TImage;
    CheckBox1: TCheckBox;
    Label13: TLabel;
    TrackBar7: TTrackBar;
    Image4: TImage;
    SavePictureDialog1: TSavePictureDialog;
    Button4: TButton;
    Label14: TLabel;
    TrackBar8: TTrackBar;
    Gauge1: TGauge;
    Label15: TLabel;
    Image5: TImage;
    Button5: TButton;
    Label16: TLabel;
    TrackBar9: TTrackBar;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Shape8: TShape;
    CheckBox6: TCheckBox;
    Button1: TButton;
    Label18: TLabel;
    EZMapImageL1: TEZMapImageL;
    EZCoarsL1: TEZCoarsL;
    EZConvertL1: TEZConvertL;
    EZProjectionL1: TEZProjectionL;
    procedure FormCreate(Sender: TObject);
    procedure DrawMap(Sender: TObject);
    procedure EZProjection1GetInfo(Sender: TObject; MapName, Text: String; TypeGeo, Reference: Boolean; EllipsType, MapNumber: Integer);
    procedure SaveImage(Sender: TObject);
    procedure EZProjection1GetConstants(Sender: TObject; Radius, Theta, Phi0, Phi1, Phi2, X0, Y0,Other,Oblique: Double);
    procedure EZMapImage1Progress(Sender: TObject; Max, Position: Integer);
    procedure ComboBoxChange(Sender: TObject);
    procedure ClearImage(Sender: TObject);
    procedure EZMapImage1Error(Sender: TObject; Return: Integer);
    procedure EZMapImageL1MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer; Lon, Lat: Double; Return: Integer);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
//------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
// Just a warnig message if 'Coast.dat' has not beeen included
if FileExists('Coast.dat') then Label18.Caption := ''
else Label18.Caption := 'The file "Coast.dat" could not be found. Coastlines can not be drawn';
// Set the values for the grid
EZmapImageL1.SetGridProperties(180,-180,90,-90,30,1);
// Get all projections. If GridInclude is set to false the UTM-gridlike projections are not displayed
// But make sure if you use SetMapProjection to substract 3 from the index number!
EZProjectionL1.GetProjectionList(ComboBox1.Items,false);
// Set to first (Orthographic);
ComboBox1.ItemIndex := 41-3;
EZProjectionL1.SetMapProjection(ComboBox1.ItemIndex+3);
// Display all Ellipsoids
EZProjectionL1.GetDatum(ComboBox2.Items);
EZProjectionL1.SetEllipsoid(220);
// But set Ellipsoid to WGS84
ComboBox2.ItemIndex := 220;
// SetDemo is used to set the default values for the current projection, adjusted to the image size
EZMapImageL1.SetDemo;
// To display the projection information use the procedure 'GetInfo'
EZProjectionL1.GetInfo;
// GetConstants evokes an GetConstants event. The event in this case sets the trackbar positions.
EZProjectionL1.GetConstants;
// Use the Button1.DrawMap event to draw all set options
DrawMap(Sender);
end;
//------------------------------------------------------------------------------
procedure TForm1.DrawMap(Sender: TObject);
var
TimeCalc : TTime;
begin
// Get current time to get the total calculation time (see bottom of procedure).
TimeCalc := Time;
// Set DrawColorMap if CheckBox1 has bee checked to true
EZMapImageL1.MapSettings.DrawColorMap := CheckBox1.Checked;
// Set all map constants for current projection type.
 EZProjectionL1.SetPrRadius(TrackBar1.Position);
 EZProjectionL1.SetPrTheta(TrackBar2.Position);
 EZProjectionL1.SetPrPhi0(TrackBar3.Position);
 EZProjectionL1.SetPrPhi1(TrackBar4.Position);
 EZProjectionL1.SetPrPhi2(TrackBar5.Position);
 EZProjectionL1.SetPrX0(EZMapImageL1.Width div 2 + TrackBar6.Position*20);
 EZProjectionL1.SetPrY0(EZMapImageL1.Height div 2 + TrackBar7.Position*20);
 EZProjectionL1.SetPrOblique(TrackBar8.Position);
 EZProjectionL1.SetPrOther(TrackBar9.Position);
// Set center  of rotaion for oblique to Theta,Phi center
 EZProjectionL1.SetPrObliqueCenter(TrackBar2.Position,TrackBar3.Position);
// If Coast.dat has been included in the EXE folder the coast can be drawn if DrawCoast has been set to true
 if CheckBox5.Checked then EZMapImageL1.MapSettings.DrawCoast := true
 else EZMapImageL1.MapSettings.DrawCoast := false;
// When drawing a line, setting AntiAlias to true wil use the LineSmooth instead of the Line procedure
// Both Line and LineSmooth are use to draw. MoveTo-LineTo is quite slow.
 if CheckBox6.Checked then EZMapImageL1.MapSettings.AntiAlias := true
 else EZMapImageL1.MapSettings.AntiAlias := false;

 // If the following line is used, the coast will not be displayed in the sunny part of the map, if property SetSun is set to true.
     // EZMapImage1.CoastDay := false;
 // This can also be done for the Night part of the map with CoastNight.

 // Draw grid. Area is set to total suface of projection with an interval of 15 with a resolution of 0.5.
 // Make sure the resolution will be smaller than the interval.
 EZMapImageL1.MapSettings.DrawGrid := CheckBox3.Checked;
 // Draw if both set to true: ColorMap and/or Coast
 EZMapImageL1.DrawAll;
 // Draw shortest route from                  San Francisco to  Athens with    interaion amount
 if CheckBox4.Checked then EZMapImageL1.DrawCoars(-122.6,37.75,  23.25,38.1,    1000);
  // Backup image so it can used by DrawEZRoute. When moveing or changing a waypoint the map needs to be redraw in a fst way. Thus a backupimage is used...
 EZMapImageL1.BackupImage;
 // Display total calculation time.
 Label8.Caption := FloatToStr(Round((Time - TimeCalc)*24*3600*1000)) + 'ms';
 // Now redraw the waypoints
// EZMapImage1.DrawEZRoute;
end;
//------------------------------------------------------------------------------
procedure TForm1.EZProjection1GetInfo(Sender: TObject; MapName,  Text: String; TypeGeo, Reference: Boolean; EllipsType, MapNumber: Integer);
begin
// some short info about the current projection type. Just a gaget.
Label8.Caption := Text;
end;
//------------------------------------------------------------------------------
procedure TForm1.SaveImage(Sender: TObject);
begin
// save current image to file
if SavePictureDialog1.Execute then EZMapImageL1.MainMap.SaveToFile(SavePictureDialog1.FileName + '.bmp');
end;
//------------------------------------------------------------------------------
procedure TForm1.EZProjection1GetConstants(Sender: TObject;Radius,Theta,Phi0,Phi1,Phi2,X0,Y0,Other,Oblique:Double);
begin
// Get and set trackbar positions for current projection constants
TrackBar1.Position   := Round(Radius);
TrackBar2.Position   := Round(Theta);
TrackBar3.Position   := Round(Phi0);
TrackBar4.Position   := Round(Phi1);
TrackBar5.Position   := Round(Phi2);
// Calculating the center is best done by getting the middle of EZMapImage1
//TrackBar6.Position   := Round(X0/20);
//TrackBar7.Position   := Round(Y0/20);
TrackBar8.Position   := Round(Other);
TrackBar9.Position   := Round(Oblique);
end;
//------------------------------------------------------------------------------
procedure TForm1.EZMapImage1Progress(Sender: TObject; Max, Position: Integer);
begin
// onProgress event to show position when drawing Coast and ColorMap
// There is no onProgress for DrawGrid and DrawCoars. These will in general not take mutch time

// End position
Gauge1.MaxValue := Max;
// Current position
Gauge1.Progress := Position;
end;
//------------------------------------------------------------------------------
procedure TForm1.ComboBoxChange(Sender: TObject);
begin
// Set projection type to selected. Note the '+3' (see above:FormCreate);
if Sender = ComboBox1 then begin
  EZProjectionL1.SetMapProjection(ComboBox1.ItemIndex+3);
  if EllipsType[EZProjectionL1.GetMapIndex] = 1 then begin
    EZProjectionL1.GetEllipsoid(ComboBox2.Items);
    EZProjectionL1.SetEllipsoid(30);
  end else begin
    EZProjectionL1.GetDatum(ComboBox2.Items);
    EZProjectionL1.SetEllipsoid(220);
  end;

end;
// Set selcted Ellipsoid
if Sender = ComboBox2 then EZProjectionL1.SetEllipsoid(ComboBox2.ItemIndex);
// SetDemo is used to set the default values for the current projection, adjusted to the image size
EZMapImageL1.SetDemo;
// To display the projection information use GetInfo
EZProjectionL1.GetInfo;
// GetConstants evokes an GetConstants event. The event in this case sets the trackbar positions.
EZProjectionL1.GetConstants;
end;
//------------------------------------------------------------------------------
procedure TForm1.ClearImage(Sender: TObject);
begin
// Clear background image and backup of backgroud image
Image1.Picture := nil;
EZMapImageL1.MainMap := nil;
end;
//------------------------------------------------------------------------------
procedure TForm1.EZMapImage1Error(Sender: TObject; Return: Integer);
begin
// Return is zero if all goes well, else the return with the corresponding description will be given.
if return <> 0 then Label8.Caption := 'Error no: '+IntToStr(Return);
end;
//------------------------------------------------------------------------------
procedure TForm1.EZMapImageL1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer; Lon, Lat: Double; Return: Integer);
begin
// If cursor position can be calculated to the corresponding geographical position
// the return value will be zero.
// if so, use EZConvert1 to convert double values for Lon,Lat to text using TxtFormat-configuration
EZConvertL1.TxtFormat := hdddmmss_ss;
if Return = 0 then begin
   EZConvertL1.GeoToTxt(Lon,Lat);
   Label8.Caption := 'Lon: ' + EZConvertL1.StringPoint.S1 + #13 + 'Lat:  ' + EZConvertL1.StringPoint.S2
// If the position pointed by the cursor can not be calculated show error-type
end else Label8.Caption := 'Error no: '+IntToStr(Return);
end;
//------------------------------------------------------------------------------
end.
