unit Conv;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, ComCtrls, Tabnotbk, EZMapValuesL, EZConvertL;

type
  TForm1 = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    Label1: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    CheckBox1: TCheckBox;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Edit17: TEdit;
    Edit18: TEdit;
    SpeedButton1: TSpeedButton;
    Label32: TLabel;
    ComboBox7: TComboBox;
    Label13: TLabel;
    ComboBox1: TComboBox;
    ComboBox4: TComboBox;
    Label17: TLabel;
    Edit9: TEdit;
    Edit10: TEdit;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label3: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    SpeedButton2: TSpeedButton;
    Label18: TLabel;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    Label19: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Edit13: TEdit;
    Edit14: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Label10: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    SpeedButton3: TSpeedButton;
    Label2: TLabel;
    Edit3: TEdit;
    Label6: TLabel;
    Edit4: TEdit;
    Memo1: TMemo;
    Image1: TImage;
    Label7: TLabel;
    Label16: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label20: TLabel;
    Edit11: TEdit;
    Label21: TLabel;
    Edit12: TEdit;
    Label22: TLabel;
    Edit15: TEdit;
    Label26: TLabel;
    Edit16: TEdit;
    Label27: TLabel;
    Edit19: TEdit;
    Label28: TLabel;
    Edit20: TEdit;
    Label36: TLabel;
    Edit21: TEdit;
    Label37: TLabel;
    Edit22: TEdit;
    Label38: TLabel;
    Edit23: TEdit;
    Label39: TLabel;
    Edit24: TEdit;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    Shape9: TShape;
    Shape10: TShape;
    Shape11: TShape;
    Shape12: TShape;
    EZConvertL1: TEZConvertL;
    procedure FormCreate(Sender: TObject);
    procedure ChangeGeoToGrid(Sender: TObject);
    procedure ChangeGridToGeo(Sender: TObject);
    procedure GeoToGridClick(Sender: TObject);
    procedure GridToGeoClick(Sender: TObject);
    procedure TranslateClick(Sender: TObject);
    procedure ToOrFrom(Sender: TObject);
    procedure EZMError(Sender: TObject; Description: String; Return: Integer);
    procedure Specific(Sender: TObject);
    procedure EZConvert1GetValues(Radius, Flattening, dX, dY, dZ, Scale,FalseEasting, FalseNorthing, CentralLong: Double; Zone: TZone);
  private
    Conversion:integer;
  public
    Procedure SetValueType(Index:integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
//------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
// Get list of possible ellipsoids, data or national grids and display first in list.
ComboBox4.ItemIndex := 0;
EZConvertL1.GetUTM(ComboBox1.Items);
ComboBox1.ItemIndex := 0;
ComboBox6.ItemIndex := 0;
EZConvertL1.GetUTM(ComboBox5.Items);
ComboBox5.ItemIndex := 0;
EZConvertL1.GetDatumUTM(ComboBox7.Items);
ComboBox7.ItemIndex := 0;
SetValueType(ComboBox4.ItemIndex);
end;
//------------------------------------------------------------------------------
procedure TForm1.ChangeGeoToGrid(Sender: TObject);
begin
// Disable the zone-edit if Grid type is set to National Grid.
if ComboBox4.ItemIndex = 2 then Edit3.Enabled := false else Edit3.Enabled := true;
// Get list of possible ellipsoids, data or national grids.
if ComboBox4.ItemIndex = 0 then EZConvertL1.GetUTM(ComboBox1.Items);
if ComboBox4.ItemIndex = 1 then EZConvertL1.GetDatumUTM(ComboBox1.Items);
if ComboBox4.ItemIndex = 2 then EZConvertL1.GetNatGrid(ComboBox1.Items);
// Display first option in combobox.
ComboBox1.ItemIndex := 0;
SetValueType(ComboBox4.ItemIndex);
EZConvertL1.GetValues(ComboBox4.ItemIndex,ComboBox1.ItemIndex);
end;
//------------------------------------------------------------------------------
procedure TForm1.ChangeGridToGeo(Sender: TObject);
begin
// Disable the zone-edit if Grid type is set to National Grid.
if ComboBox6.ItemIndex = 2 then Edit4.Enabled := false else Edit4.Enabled := true;
// Get list of possible ellipsoids, data or national grids.
if ComboBox6.ItemIndex = 0 then EZConvertL1.GetUTM(ComboBox5.Items);
if ComboBox6.ItemIndex = 1 then EZConvertL1.GetDatumUTM(ComboBox5.Items);
if ComboBox6.ItemIndex = 2 then EZConvertL1.GetNatGrid(ComboBox5.Items);
// Display first option in combobox.
ComboBox5.ItemIndex := 0;
SetValueType(ComboBox6.ItemIndex);
EZConvertL1.GetValues(ComboBox6.ItemIndex,ComboBox5.ItemIndex);
end;
//------------------------------------------------------------------------------
procedure TForm1.GeoToGridClick(Sender: TObject);
begin
// Read geographical text and convert to internal float values.
EZConvertL1.TxtToGeo(Edit10.Text,Edit9.Text);
// Calculate zone and set zone
EZConvertL1.UTMZone := EZConvertL1.CalcZone(EZConvertL1.FloatPoint.X,EZConvertL1.FloatPoint.Y);
// Convert geographical data to appropriate grid.
if ComboBox4.ItemIndex = 0 then EZConvertL1.GeoToUTM(EZConvertL1.FloatPoint.X,EZConvertL1.FloatPoint.Y,ComboBox1.ItemIndex);
if ComboBox4.ItemIndex = 1 then EZConvertL1.GeoToDatumUTM(EZConvertL1.FloatPoint.X,EZConvertL1.FloatPoint.Y,ComboBox1.ItemIndex);
if ComboBox4.ItemIndex = 2 then EZConvertL1.GeoToNationalGrid(EZConvertL1.FloatPoint.X,EZConvertL1.FloatPoint.Y,ComboBox1.ItemIndex);
// Display grid data.
Edit5.Text := FloatToStr(EZConvertL1.FloatPoint.X);
Edit6.Text := FloatToStr(EZConvertL1.FloatPoint.Y);
Edit3.Text := EZConvertL1.UTMZone;
EZConvertL1.GetValues(ComboBox4.ItemIndex,ComboBox1.ItemIndex);
end;
//------------------------------------------------------------------------------
procedure TForm1.GridToGeoClick(Sender: TObject);
begin
// Read grid-text and convert to internal float values.
EZConvertL1.FloatPoint.X := StrToFloat(Edit13.Text);
EZConvertL1.FloatPoint.Y := StrToFloat(Edit14.Text);
EZConvertL1.UTMZone := Edit4.Text;
// Convert grid data to geographical data.
if ComboBox6.ItemIndex = 2 then EZConvertL1.NationalGridToGeo(EZConvertL1.FloatPoint.X,EZConvertL1.FloatPoint.Y,ComboBox5.ItemIndex);
if ComboBox6.ItemIndex = 1 then EZConvertL1.DatumUTMtoGeo(EZConvertL1.FloatPoint.X,EZConvertL1.FloatPoint.Y,ComboBox5.ItemIndex);
if ComboBox6.ItemIndex = 0 then EZConvertL1.UTMtoGeo(EZConvertL1.FloatPoint.X,EZConvertL1.FloatPoint.Y,ComboBox5.ItemIndex);
// convert float values to geographical text.
EZConvertL1.GeoToTxt(EZConvertL1.FloatPoint.X,EZConvertL1.FloatPoint.Y);
// Display geographical data.
Edit7.Text := EZConvertL1.StringPoint.S1;
Edit8.Text := EZConvertL1.StringPoint.S2;
EZConvertL1.GetValues(ComboBox6.ItemIndex,ComboBox5.ItemIndex);
end;
//------------------------------------------------------------------------------
procedure TForm1.TranslateClick(Sender: TObject);
begin
// Read geographical text and convert to internnal float values.
EZConvertL1.TxtToGeo(Edit1.Text,Edit2.Text);
// Translate to or from WGS84.
EZConvertL1.Translate(CheckBox1.Checked,EZConvertL1.FloatPoint.X,EZConvertL1.FloatPoint.Y,ComboBox7.ItemIndex);
// convert float values to geographical text.
EZConvertL1.GeoToTxt(EZConvertL1.FloatPoint.X,EZConvertL1.FloatPoint.Y);
// Display geographical data.
Edit17.Text := EZConvertL1.StringPoint.S1;
Edit18.Text := EZConvertL1.StringPoint.S2;
end;
//------------------------------------------------------------------------------
procedure TForm1.ToOrFrom(Sender: TObject);
begin
// Just for clarification.
if CheckBox1.Checked then begin
   Label1.Caption  := 'WGS84 in';
   Label31.Caption := 'To lokal';
end else begin
   Label1.Caption  := 'Lokal in';
   Label31.Caption := 'To WGS84';
end;
end;
//------------------------------------------------------------------------------
procedure TForm1.EZMError(Sender: TObject; Description: String;
  Return: Integer);
begin
  MessageDlg(Description, mtError,[mbOK], 0);
end;
//------------------------------------------------------------------------------
procedure TForm1.Specific(Sender: TObject);
begin
With Sender as TComboBox do begin
  if Sender = ComboBox1 then EZConvertL1.GetValues(ComboBox4.ItemIndex,ComboBox1.ItemIndex);
  if Sender = ComboBox5 then EZConvertL1.GetValues(ComboBox6.ItemIndex,ComboBox5.ItemIndex);
  if Sender = ComboBox7 then begin
     EZConvertL1.GetValues(1,ComboBox7.ItemIndex);
     SetValueType(1);
  end;
end;
end;
//------------------------------------------------------------------------------
procedure TForm1.SetValueType(Index:integer);
begin
if Index = 0 then begin
   Edit11.Enabled := true;
   Edit12.Enabled := true;
   Edit15.Enabled := false;
   Edit16.Enabled := false;
   Edit19.Enabled := false;
   Edit20.Enabled := true;
   Edit21.Enabled := true;
   Edit22.Enabled := false;
   Edit23.Enabled := false;
   Edit24.Enabled := false;
end else if Index = 1 then begin
   Edit11.Enabled := true;
   Edit12.Enabled := true;
   Edit15.Enabled := true;
   Edit16.Enabled := true;
   Edit19.Enabled := true;
   Edit20.Enabled := true;
   Edit21.Enabled := true;
   Edit22.Enabled := false;
   Edit23.Enabled := false;
   Edit24.Enabled := false;
end else if Index = 2 then begin
   Edit11.Enabled := true;
   Edit12.Enabled := true;
   Edit15.Enabled := false;
   Edit16.Enabled := false;
   Edit19.Enabled := false;
   Edit20.Enabled := false;
   Edit21.Enabled := true;
   Edit22.Enabled := true;
   Edit23.Enabled := true;
   Edit24.Enabled := true;
end;
Conversion := index;
end;
//------------------------------------------------------------------------------
procedure TForm1.EZConvert1GetValues(Radius, Flattening, dX, dY, dZ, Scale,FalseEasting, FalseNorthing, CentralLong: Double; Zone: TZone);
begin
Edit11.Text := FloatToStr(Radius);
Edit12.Text := FloatToStr(Flattening);
Edit15.Text := FloatToStr(dX);
Edit16.Text := FloatToStr(dY);
Edit19.Text := FloatToStr(dZ);
Edit20.Text := Zone;
Edit21.Text := FloatToStr(Scale);
Edit22.Text := FloatToStr(FalseEasting);
Edit23.Text := FloatToStr(FalseNorthing);
Edit24.Text := FloatToStr(CentralLong);
end;
//------------------------------------------------------------------------------
end.
