unit EZMapValuesL;

interface

uses windows, Classes, SysUtils, Graphics, Math, Types, Controls;

type
  PRGBTriple = ^TRGBTriple;
  TRGBTriple = packed record
     B: byte;  {easier to type than rgbtBlue}
     G: byte;
     R: byte;
  end;
  pRGBTripleArray = ^TRGBTripleArray;
  TRGBTripleArray = array[0..32767] of TRGBTriple;

  TFloatPoint = record
     X,Y : Double;
  end;

  TFlag = integer;

  TZone = string[3];

  TStringPoint = record
    S1, S2 : string;
  end;

  TProjection = (mpOrthographic     ,mpUTM             ,mpDatumUTM   ,mpNationalGrid ,mpWinkelI,
                 mpSinusoidal       ,mpEquirectangular ,mpBStereo    ,mpHammer       ,mpGvnsp,
                 mpAzimuthalEA      ,mpLaAzimuthalEA   ,mpGrinten    ,mpPolyconic    ,mpRobinson,
                 mpLaConformalConic ,mpGnomonic        ,mpTMercator  ,mpCassiniS     ,mpMercator,
                 mpMollweide        ,mpWagnerIV        ,mpWagnerVII  ,mpIMollweide   ,mpEDConical,
                 mpAlbertsCEA       ,mpStereographic   ,mpEckertII   ,mpWinkelII     ,mpBonne,
                 mpLamCylindricalEA ,mpBerCylindricalEA,mpTristanEdwards,mpPeters    ,mpGallOrth,
                 mpBalthasart       ,mpCollignon       ,mpEckertI    ,mpEckertIII    ,mpPutnins,
                 mpKavraiskyVII     ,mpWagnerVI        ,mpEckertV    ,mpCraster      ,mpEckertIV,
                 mpFahey            ,mpFoucautS        ,mpGall       ,mpEckertVI     ,mpMcBryde,
                 mpLoximuthal       ,mpMiller          ,mpNell       ,mpFoucaut      ,mpKavraiskyV,
                 mpMcBrydeSin       ,mpQuarticAu       ,mpWagnerII   ,mpWagnerIII    ,mpUrmaev,
                 mpWagnerI          ,mpUrmaevV         ,mpMcBrydeSin2,mpMcBrydeP     ,mpMcBrydeQ,
                 mpPutnins2);
  TOutPut     = (ofGeographic	    ,ofUTM             ,ofDatumUTM   ,ofNationalGrid);
  TInPut      = (ifGeographic       ,ifUTM             ,ifDatumUTM   ,ifNationalGrid);
  TDistance   = (dsFathom           ,dsFoot            ,dsFootUS     ,dsInch         ,dsLink,
                 dsMile             ,dsMileNautUK      ,dsMileNautInt,dsMileNautSea  ,dsPerch,
                 dsYard             ,dsMeter           ,dsKilometer);
  TSpeed      = (spKmh              ,spMs              ,spMileh      ,spKnotsUK      ,spKnots);
  TFormat     = (d_dddddddd         ,sddd_dddddd       ,sdddmm_mmmm  ,sdddmmss_ss    ,hddd_dddddd,
                 hdddmm_mmmm        ,hdddmmss_ss);
  TEZMapSet   = (ezNone             ,ezScan            ,ezRef        ,ezRefSet       ,ezRefAdjP,
                 ezRefAdjA);
  TExeType    = (exMap              ,exUserGrid        ,exMarker     ,exAbout        ,exColorMap,
                 exIO               ,exTxtFormat       ,exGrid       ,exZone);
  TMarkType   = (mtSquare           ,mtCircle          ,mtCross);
  THeadType   = (htCircle           ,htTriangle);

  TRotate = record
    X0,Y0,Angle:Double;
  end;

  TFP = record
      X,Y,X0,Y0 : Double;
      A1,A2,B1,B2 : Double;
  end;

  TFPp = record
      X,Y,Theta,Phi : Double;
  end;

  TGrid = record
      East,West,North,South,Interval,Resolution : Double;
  end;

  TUserDat = record
     R,F,FE,FN,S,L:Double;
  end;

  TCoastL = record
    lon,lat : double
  end;

  TCoastLine = array [0..59766] of TCoastL;

  TVal = record
                                                                                // Map parameters       Orth   UTM  Datum NatGr WinkelI WinkelI Sinus  EquiCyl Bster   Hammer  AzimuthalEA  LaAEA  Grinten Polyconic Robinson LaCConic Gnomonic TMerc  Cassini Merc   Mollweide WagnerIV WagVII  IMolw  ConcalED Gvnsp  AlbertsCEA Stereo  EckerT
    Rad : Double;                                                               // in pixels            R      A1   A1    A1    R       R       R      R       R       R       R      	    R      R       R         R        R        R        R      R       R      R         R        R       R      R        R      R          R       R
    Th0 : Double;                                                                                  //   Theta0 A2   A2    A2    Theta0  Theta0  Theta0 Theta0  Theta0  Theta0  Theta0       Theta0 Theta0  Theta0    Theta0   Theta0   Theta0   Theta0 Theta0  Theta0 Theta0    Theta0   Theta0  Theta0 Theta0   Theta0 Theta0	   Theta0  Theta0
    Ph0 : Double;                                                                                  //   Phi0   A3   A3    A3                                                   Phi0         Phi0                                       Phi0                                                                      Phi0              Phi0
    Ph1 : Double;                                                                                  //          B1   B1    B1                                                                                                  Phi1                                                                      Phi1            Phi1
    Ph2 : Double;                                                                                  //          B2   B2    B2                                                                                                  Phi2                                                                      Phi2            Phi2
    X0  : Double;                                                                                  //   X0     B3   B3    B3    X0      X0      X0     X0      X0      X0      X0           X0     X0      X0        X0       x0       X0       X0     X0      X0     X0        X0       X0      X0     X0       x0     X0         X0      X0
    Y0  : Double;                                                                                  //   Y0                      Y0      Y0      Y0     Y0      Y0      Y0      Y0           Y0     Y0      Y0        Y0       Y0       Y0       Y0     Y0      Y0     Y0        Y0       Y0      Y0     Y0       Y0     Y0         Y0      Y0
    H0  : Double;                                                                                  //                                                                                                                                                                                                   mode     height
                                                                                // Oblate parameters ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    Oa : Double;                                                                                   //   Oblique angle
    Ot : Double;                                                                                   //   Theta center rotation in radians
    Op : Double;                                                                                   //   Phi   center rotation in radians
                                                                                //  Scan adjustments ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    Rx : Double;                                                                                   //   Rotation center X in pixles
    Ry : Double;                                                                                   //   Rotation center Y in pixels
    Ra : Double;                                                                                   //   Rotation Angle in radians
    Zone : string[3];
  end;

  TRef = record
    Calculated  : boolean;                                                      // Has the map been calculated by using CalcRef or by SetDemo. This is just to prevent possible problems. If set to false no calculation will be performed. Set to true if you need to.
    Comments    : string[255];                                                  // Some additional information if you like. It will be used by EZMap as caption on EZMapForm.
    CountRef    : integer;                                                      // Number of reference points added
    MapName     : string[255];                                                  // Name for the map
    GridProp    : TGrid;                                                        // Range for the geographic grid to be drawn
    Input       : TInPut;                                                       // Input format: Geographic, UTM,....
    InputIndex  : integer;                                                      // What subtype is used for input. Like a lokal UTM it could used 'North American 1927:Alberta,British Columbia' with value of 119.
    MapIndex    : integer;                                                      // What subtype is used for the  projection. Like Mercator uses an ellipsoid. So '23' would be 'Krassovsky 1940'.
    Output      : TOutPut;                                                      // Output format: Geographic, UTM,....
    OutputIndex : integer;                                                      // Same as InputIndex
    Points      : array [0..29] of TFPp;                                        // Array for reference points (lon,lat,X,Y)
    Projection  : TProjection;                                                  // Projection type used (Orthographic, Mercator, UTM,....)
    Values      : TVal;                                                         // All constants needed for the projections
    Zone        : string[3];                                                    // UTM or lokal UTM zone
    Version     : integer;                                                      // might be usefull if any alterations are made to these componts
  end;
                                                                                // ID code used by EZRoute to provide hikes, posts, etc with a unique ID. ThisID is used by EZRoute view. (DO NOT RESET ID !! This might give problems)
  TID = string[8];
                                                                                // types from TEZMapImage

  TPoly = array[1..3] of TPoint;

  TDrawMode   = (dmNone, dmRoute, dmMove, dmTrack, dmMarker, dmWaypoint);
  TMode       = (mmNone, mmMove, mmAdd, mmDelete, mmEdit, mmInsert);
  TDrawStatus = (dsNone,dsMove);
  TCheckT     = (ctEnabled,ctChecked,ctGray);

  TRouteStruct = record
    Hike    : integer;
    Route   : integer;
    Post    : integer;
    Marker  : integer;
    Way     : integer;
    WayPoint: integer;
    Track   : integer;
    Map     : integer;
    Main    : integer;
    ID      : TID;
    Expanded: boolean;
    Selected: boolean;
    Check   : TCheckT;
  end;

  TUndoType = record
    ID,ID2  : TID;
    Tag     : integer;
    A,B,C   : integer;
  end;

  TMapCall = record
    OldLon,OldLat : Double;
    NewLon,NewLat : Double;
    PlugInName    : string[255];
    PlugInFunc    : integer;
    Heading       : Double;
    Move          : boolean;
    OffsetX       : integer;
    OffsetY       : integer;
    OldXOff       : integer;
    OldYOff       : integer;
  end;

   TMapOut = record
     ImageTop    : integer;                                                     // EZMapImage.Top position in relation to frame
     ImageLeft   : integer;                                                     // EZMapImage.Left position in relation to frame
     ImageWidth  : integer;                                                     // New EZMapImage width
     ImageHeight : integer;                                                     // New EZMapImage Height
     Map         : TBitmap;                                                     // the map
     MapVisible  : boolean;                                                     // true if map needs to be redrawn
     MapReference: TRef;                                                        // new values for EZProjection.MapRef. So other calculations can be mad.
     Longtitude  : Double;                                                      // Return lon/Lat. If search-function used Lon/Lat are unknown.
     Lattitude   : Double;
   end;

   TMapInVar = record
     Scale       : Double;
     Bool        : array[0..20] of boolean;
     Int         : array[0..20] of integer;
     Doub        : array[0..20] of Double;
     Str         : array[0..20] of String;
   end;

   TDllMapInfo = record
     Name        : string[255];                                                 // Collection name. Will be used in menu sub-item
     Number      : integer;                                                     // Number of map functions
     Funct       : array[0..10] of string[255];                                 // Function name. Will be used as sub-sub-menuitem
     HintText    : array[0..10] of string[255];                                 // Hint text for button
     ActOnGps    : array[0..10] of boolean;                                     // If set to true it is presumed the function returns a map together with the location. If the function is a search function it will not be wise to use the function in combination with a gps to search for a location when you need to use a form after each GPS call.
     Image       : array[0..10] of TBitmap;                                     // Menu image
   end;

  TUserE = record
     Name        : string[255];
     Radius      : Double;
     Flattening  : Double;
     Scale       : Double;
     Zone        : string[3];
  end;


  TUserD = record
     Name        : string[255];
     Radius      : Double;
     Flattening  : Double;
     dX          : Double;
     dY          : Double;
     dZ          : Double;
     Scale       : Double;
     Zone        : string[3];
  end;

  TUserN = record
     Name        : string[255];
     Radius      : Double;
     Flattening  : Double;
     FalseEast   : Double;
     FalseNorth  : Double;
     Scale       : Double;
     CenterLon   : Double;
  end;

  TUserEllips       = array [0..9] of TUserE;
  TUserDatum        = array [0..9] of TUserD;
  TUserNationalGrid = array [0..9] of TUserN;

  TUser = record
     NE,ND,NN: integer;
     Ellips  : TUserEllips;
     Datum   : TUserDatum;
     NatGrid : TUserNationalGrid;
  end;

  TCoars = record
     Distance : Double;
     Coars    : Double;
     Lon      : Double;
     Lat      : Double;
     FlightDir: Double;
     GroudSpd : Double;
  end;

  TErrorEvent    = procedure (Sender: TObject; Return:integer) of object;
  TForEvent      = procedure (Sender: TObject; X,Y:Double;Return:integer) of object;
  TInvEvent      = procedure (Sender: TObject; Theta,Phi:Double;Return:integer) of object;
  TGetInfoEvent  = procedure (Sender: TObject; MapName:string; TypeGeo,Reference:boolean;EllipsType,MapNumber:integer) of object;
  TGetConstants  = procedure (Sender: TObject; Radius,Theta,Phi0,Phi1,Phi2,X0,Y0,Oblique,Other:Double) of object;
  TIOFormat      = procedure (Sender: TObject; InFormat,OutFormat,InIndex,OutIndex:integer) of object;
  TGetValues     = procedure (Radius,Flattening,dX,dY,dZ,Scale,FalseEasting,FalseNorthing,CentralLong:Double;Zone:TZone) of object;
  TDisEv         = procedure (Distance,Coars : Double) of object;
  TEndpoint      = procedure (Lon2,Lat2 : Double) of object;
  TFlight        = procedure (FlightDirection,GroundSpeed : Double) of object;
  TMouseMove     = procedure (Sender: TObject; Shift: TShiftState; X, Y: Integer; Lon, Lat : Double;Return:integer) of object;
  TMouseEvent    = procedure (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Lon, Lat : Double;Return:integer) of object;
  TProgress      = procedure (Sender: TObject; Max,Position:integer) of object;
  TEZPaintEvent  = procedure (Sender: TObject; Canvas: TCanvas) of Object;

  function  NearLine(XC,YC,XA,YA,XB,YB,Tolerance: Double): Boolean;
  function  GetPoly(X0,Y0,Size:integer;Angle,Heading:Double):TPoly;
  function  NewPos(X,Y,X0,Y0:integer;Angle:Double):TPoint;
  function  InArea(X,Y,Xt,Yt,Fuzz:integer):boolean;
  procedure ZoomIt(Source,Target:TBitmap;X,Y,Zoom:integer);
  procedure DrawArrow(Bitmap:TBitmap;X,Y,Angle,Degrees,Size:integer;Comment:string;Color:TColor;F:TFont;AA:Boolean);
  function  GetTmpDir: string;
  procedure ClearUndoTmp;
  procedure StringToStream(Str:String;Stream:TMemoryStream);
  function  StreamToString(Stream:TMemoryStream):string;
  procedure BitmapToStream(Bitmap:TBitmap;Stream:TMemoryStream);
  procedure StreamToBitmap(Bitmap:TBitmap;Stream:TMemoryStream);
  procedure StringsToStream(Strs:TStrings;Stream:TMemoryStream);
  procedure StreamToStrings(Strs:TStrings;Stream:TMemoryStream);
  procedure LineSmooth(X1,Y1,X2,Y2:Integer;Bitmap:TBitmap;Color:TColor;LineWidth:Double;AntiAlias:Boolean);
  function  SetFloatPoint(X,Y:double):TFloatPoint;


implementation
////////////////////////////////////////////////////////////////////////////////
procedure LineSmooth(X1,Y1,X2,Y2:Integer;Bitmap:TBitmap;Color:TColor;LineWidth:Double;AntiAlias:Boolean);
var
I,J,dif,U,dy1,dy2: Integer;
D        : Double;
Row      : pRGBTripleArray;
Clrt,Tmp : TRGBTriple;
B,B1     : byte;
HadMax   : boolean;
  //----------
  function Distance(XC,YC,XA,YA,XB,YB,W:Double): double;
  var
    L,S,A,B: Double;
  begin
    L:=SQRT(SQR(XB-XA)+SQR(YB-YA));
    A:=SQRT(SQR(XC-XA)+SQR(YC-YA));
    B:=SQRT(SQR(XC-XB)+SQR(YC-YB));
    if (l<>0) and (A <= L) and (B <= L) then begin
      S:= ((YA-YC)*(XB-XA)-(XA-XC)*(YB-YA))/(L*L);
      result := abs(S*L);
    end else if (A <= W) then result := A
    else if (B <= W) then result := B
    else Result := W*2;
  end;
  //-------------
  function IsOK(Bitmap:TBitmap;X,Y:integer):boolean;
  begin
    Result := false;
    if (X >= 0) and (X < Bitmap.Width) and (Y >= 0) and (Y < Bitmap.Height) then result := true;
  end;
  //-------------
  function GetB(D,W:Double):byte;
  var
    T : Double;
  begin
    T := W-D;
    if (T > 3) then Result := 255
    else if (T <= 0) then Result := 0
    else result := Trunc(sqr(Sin(T/2))*255);
  end;
  //-------------
  procedure SetPix(Bitmap:TBitmap;X,Y:integer;B:Byte;Col:TRGBTriple);
  begin
    if IsOK(Bitmap,X,Y) then begin
       Row := Bitmap.ScanLine[Y];
       Tmp := Row[X];
       Tmp.b:=((Col.B*B)+(Tmp.B*(255 xor B)))shr 8;
       Tmp.g:=((Col.G*B)+(Tmp.G*(255 xor B)))shr 8;
       Tmp.r:=((Col.R*B)+(Tmp.R*(255 xor B)))shr 8;
       Row[X] := Tmp;
     end;
  end;
  //-------------
  function Outside(X1,X2,Y1,Y2:integer;Bitmap:TBitmap):boolean;
  begin
   result := false;
   if ((X1 < 0) or (X1 > Bitmap.Width)) and ((X2 < 0) or (X2 > Bitmap.Width))
      and ((Y1 < 0) or (Y1 > Bitmap.Height)) and ((Y2 < 0) or (Y2 > Bitmap.Height))
      then result := true;
  end;
  //-------------
begin
  if LineWidth < 1 then Exit;
  if Outside(X1,X2,Y1,Y2,Bitmap) then Exit;
  if ((X1 >= X2) and (Y1 > Y2)) or (X1 <= X2) and (Y1 >= Y2) then begin
    U  := X1;
    X1 := X2;
    X2 := U;
    U  := Y1;
    Y1 := Y2;
    Y2 := U;
  end;

  if not AntiAlias then begin
    Bitmap.Canvas.Pen.Width  := Trunc(LineWidth);
    Bitmap.Canvas.Pen.Color  := Color;
    Bitmap.Canvas.Pen.Style  := psSolid;
    Bitmap.Canvas.MoveTo(X1,Y1);
    Bitmap.Canvas.LineTo(X2,Y2);
    exit;
  end;

  LineWidth := LineWidth+2;
  dif := trunc(1+LineWidth/2);

  with clrt do begin
    R := GetRValue(Color);
    G := GetGValue(Color);
    B := GetBValue(Color);
  end;


 if ((X2-X1)*(Y2-Y1) >= 0) and ((Y2-Y1) <> 0) then begin
  dy1 := Y1-dif;
  for I := X1-Dif to X2+dif do begin
    J  := dy1;
    dy2 := Y2+dif;
    B1 := 0;
    HadMax := false;
    repeat
      D := abs(Distance(I,J,X1,Y1,X2,Y2,LineWidth)*2);
      B := GetB(D,LineWidth);

      if (D <= LineWidth) then SetPix(Bitmap,I,J,B,Clrt);

      if (B < B1) then HadMax := true;
      if (B > 0) and (B1 = 0) and not HadMax then dy1 := J-1;
      if HadMax and (B = 0) then dy2 := J;

      B1 := B;

      Inc(J);
    until (J >= dy2);
  end;
 end else begin
  dy1 := Y1-dif;
  for I := X1+Dif+1 downto X2-dif do begin
    J  := dy1;
    dy2 := Y2+dif;
    B1 := 0;
    HadMax := false;
    repeat

      D := abs(Distance(I,J,X1,Y1,X2,Y2,LineWidth)*2);
      B := GetB(D,LineWidth);

      if (D <= LineWidth) then SetPix(Bitmap,I,J,B,Clrt);

      if (B < B1) then HadMax := true;
      if (B > 0) and (B1 = 0) and not HadMax then dy1 := J-1;
      if HadMax and (B = 0) then dy2 := J;

      B1 := B;

      Inc(J);
    until (J >= dy2);
  end;
 end;
end;
//------------------------------------------------------------------------------
procedure StreamToStrings(Strs:TStrings;Stream:TMemoryStream);
var
 Sz,I,J,N : integer;
begin
 Stream.Read(Sz,SizeOf(Integer));
 N := Stream.Position + Sz;
 Strs.Clear;
 if Sz > 0 then begin
   Stream.Read(J,SizeOf(Integer));
   for I := 0 to J do
   Strs.Add(StreamToString(Stream));
   Stream.Position := N;
 end;
end;
//------------------------------------------------------------------------------
procedure StringsToStream(Strs:TStrings;Stream:TMemoryStream);
var
 Temp : TMemoryStream;
 Sz,I,J : integer;
begin
 Temp := TMemoryStream.Create;
 J := Strs.Count-1;
 Temp.Write(J,SizeOf(Integer));
 for I := 0 to Strs.Count-1 do StringToStream(Strs.Strings[I],Temp);
 Sz := Temp.Position;
 Temp.Free;

 Stream.Write(Sz,SizeOf(Integer));
 if Sz > 0 then begin
   J := Strs.Count-1;
   Stream.Write(J,SizeOf(Integer));
   for I := 0 to Strs.Count-1 do StringToStream(Strs.Strings[I],Stream);
 end;
end;
//------------------------------------------------------------------------------
procedure StreamToBitmap(Bitmap:TBitmap;Stream:TMemoryStream);
var
 Sz,N : integer;
begin
 Stream.Read(Sz,SizeOf(integer));
 N := Stream.Position + Sz;                                                     // Get Position after loading bitmap
 if Sz > 0 then begin
//    Bitmap := TBitmap.Create;
    Bitmap.LoadFromStream(Stream);
    Stream.Position := N;                                                       // Set to good position
 end;
end;
//------------------------------------------------------------------------------
procedure BitmapToStream(Bitmap:TBitmap;Stream:TMemoryStream);
var
 Temp : TMemoryStream;
 Sz   : integer;
begin
 Temp := TMemoryStream.Create;
 Bitmap.SaveToStream(Temp);
 Sz := Temp.Size;
 Temp.Free;
 Stream.Write(Sz,SizeOf(Integer));
 if Sz > 0 then Bitmap.SaveToStream(Stream);
end;
//------------------------------------------------------------------------------
procedure StringToStream(Str:String;Stream:TMemoryStream);
var
 C,I : byte;
begin
  C := Length(Str);
  Stream.write(C,SizeOf(byte));
  for I := 1 to C do Stream.write(Str[I],SizeOf(char));
end;
//------------------------------------------------------------------------------
function StreamToString(Stream:TMemoryStream):string;
var
 C,I : byte;
 Ch : char;
begin
  result := '';
  Stream.Read(C,SizeOf(byte));
  for I := 1 to C do begin
     Stream.Read(Ch,SizeOf(char));
     result := result + ch;
  end;
end;
//------------------------------------------------------------------------------
function GetPoly(X0,Y0,Size:integer;Angle,Heading:Double):TPoly;
var
 dif : double;
begin
 dif := Angle/2;
 Result[1].X := X0-1;
 Result[1].Y := Y0-1;

 Result[2] := NewPos(X0,Y0-Size,X0,Y0,Heading+180-dif);
 Result[3] := NewPos(X0,Y0-Size,X0,Y0,Heading+180+dif);
end;
//------------------------------------------------------------------------------
function NewPos(X,Y,X0,Y0:integer;Angle:Double):TPoint;
var
 X1,Y1:integer;
 a : Double;
begin
 a := -DegToRad(Angle);
 X1 :=  X - X0;
 Y1 :=  Y - Y0;
 Result.X :=  Round( Cos(a)*(X1) + Sin(a)*(Y1) + X0);
 Result.Y :=  Round(-Sin(a)*(X1) + Cos(a)*(Y1) + Y0);
end;
//------------------------------------------------------------------------------
function InArea(X,Y,Xt,Yt,Fuzz:integer):boolean;
var
 r : Double;
begin
  if (abs(X) < 32000) and (abs(Y) < 32000) and
     (abs(Xt) < 32000) and (abs(Yt) < 32000) then begin
   r := sqrt(sqr(X-Xt) + sqr(Y-Yt));                                            // distance betwee targetpoint and point
   if r > Fuzz then result := false
   else result := true;
  end else result := false;
end;
//------------------------------------------------------------------------------
function NearLine(XC,YC,XA,YA,XB,YB,Tolerance: Double): Boolean;
var
L,R,S: Double;
begin
  Result:=False;
  L:=SQRT(((XB-XA)*(XB-XA)+(YB-YA)*(YB-YA)));
  if l<>0 then
  begin
    R:= ((YA-YC)*(YA-YB)-(XA-XC)*(XB-XA))/(L*L);
    S:= ((YA-YC)*(XB-XA)-(XA-XC)*(YB-YA))/(L*L);
    if (r>0) and (r<1) then
        if Abs(S*L)<=Tolerance then Result:=True;  //s*l=distance
  end;
end;
//------------------------------------------------------------------------------
procedure ZoomIt(Source,Target:TBitmap;X,Y,Zoom:integer);
var
  Sw,Sh,Tw,Th,Dw,Dh:integer;
  SX1,SX2,SY1,SY2:integer;
  TX1,TX2,TY1,TY2:integer;
begin
  Sw  := Source.Width;
  Sh  := Source.Height;
  Tw  := Target.Width;
  Th  := Target.Height;
  Dw  := Tw div 2;
  Dh  := Th div 2;

  TX1 := 0;
  TX2 := Tw;
  TY1 := 0;
  TY2 := Th;

  SX1 := X - Dw div Zoom;
  SX2 := X + Dw div Zoom;
  SY1 := Y - Dh div zoom;
  SY2 := Y + Dh div Zoom;

  if SX1 < 0  then begin TX1 := TX1-SX1*Zoom; SX1 := 0; end;
  if SX2 > Sw then begin TX2 := TX2+(Sw-SX2)*Zoom; SX2 := Sw; end;
  if SY1 < 0  then begin TY1 := TY1-SY1*Zoom; SY1 := 0; end;
  if SY2 > Sh then begin TY2 := TY2+(Sh-SY2)*Zoom; SY2 := Sh; end;

  Target.Canvas.Brush.Color := clBlack;
  Target.Canvas.FillRect(Rect(0,0,Tw,Th));

  Target.Canvas.CopyRect(Rect(TX1,TY1,TX2,TY2),Source.Canvas,Rect(SX1,SY1,SX2,SY2));
end;
//------------------------------------------------------------------------------
procedure DrawArrow(Bitmap:TBitmap;X,Y,Angle,Degrees,Size:integer;Comment:string;Color:TColor;F:TFont;AA:Boolean);
var
  Pol  : TPoly;
  Pos  : TPoint;
  P,H  : integer;
begin
  Bitmap.Canvas.Pen.Style   := psClear;
  Bitmap.Canvas.Brush.Color := Color;
  Bitmap.Canvas.Brush.Style := bsSolid;

  Pol                := GetPoly(X,Y,Size,Degrees,Angle);
  Bitmap.Canvas.Polygon(pol);
  LineSmooth(Pol[1].X,Pol[1].Y,Pol[2].X,Pol[2].Y,Bitmap,Color,1,AA);
  LineSmooth(Pol[2].X,Pol[2].Y,Pol[3].X,Pol[3].Y,Bitmap,Color,1,AA);
  LineSmooth(Pol[3].X,Pol[3].Y,Pol[1].X,Pol[1].Y,Bitmap,Color,1,AA);

  Bitmap.Canvas.Brush.Style := bsClear;
  Bitmap.Canvas.Font.Assign(F);
  Bitmap.Canvas.Font.Color := Color;

  P := Bitmap.Canvas.TextWidth(Comment);
  H := Bitmap.Canvas.TextHeight(Comment) div 2;

  Pos := NewPos(X,Y+Size+H,X,Y,Angle);
  Angle := Angle Mod 360;

  if Angle < 180 then Bitmap.Canvas.TextOut(Pos.x-p,Pos.y - H,Comment)
  else Bitmap.Canvas.TextOut(Pos.x,Pos.y - H,Comment);
end;
//------------------------------------------------------------------------------
function GetTmpDir: string;                                                     // Get the windows temporary directory
var
  pc: PChar;
begin
  pc := StrAlloc(MAX_PATH + 1);
  GetTempPath(MAX_PATH, pc);
  Result := string(pc);
  StrDispose(pc);
end;
//------------------------------------------------------------------------------
procedure ClearUndoTmp;
var
  I: Integer;
  SearchRec: TSearchRec;
  TempDir : string;
begin
  TempDir := GetTmpDir;
  try
    I := FindFirst(TempDir + 'EZ*.tmp',$0000003F, SearchRec);
    While I = 0 do begin
      I := FindNext(SearchRec);
      DeleteFile(TempDir + SearchRec.Name);
    end;
    FindClose(SearchRec);
  except
    raise;
  end;
end;
//------------------------------------------------------------------------------
function SetFloatPoint(X,Y:double):TFloatPoint;
begin
 Result.X := X;
 Result.Y := Y;
end;
////////////////////////////////////////////////////////////////////////////////
end.
