unit RegAppCfgDataEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DesignIntf, TypInfo, StdCtrls, Designeditors, Grids, ValEdit;

type
  TfmRegAppCfgDataEdit = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Edit4: TEdit;
    Label4: TLabel;
    Edit5: TEdit;
    Label5: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label6: TLabel;
    Button3: TButton;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TRegAppCfgDataProperty = class(TStringProperty)
  private
    EditForm: TfmRegAppCfgDataEdit;
    procedure ChBox1Click(Sender: TObject);
    procedure Btn1Click(Sender: TObject);
    procedure Btn2Click(Sender: TObject);
    procedure Btn3Click(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure GetValues;
    procedure SetValues;
    function GetValue: String; Override;
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

procedure Register;

var
  fmRegAppCfgDataEdit: TfmRegAppCfgDataEdit;

implementation
uses mRegApp;

{$R *.DFM}

procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(TRegAppCfgData), TmRegApp, 'ConfigData', TRegAppCfgDataProperty);
end;

{ TCaptionProperty }

procedure TRegAppCfgDataProperty.Btn1Click(Sender: TObject);
begin
  SetValues;
  GetValues;
end;

procedure TRegAppCfgDataProperty.Btn2Click(Sender: TObject);
begin
  EditForm.Close;
end;

procedure TRegAppCfgDataProperty.Btn3Click(Sender: TObject);
begin
  with EditForm do
    TmRegApp(GetComponent(0)).ClearReg;
  GetValues;
end;

procedure TRegAppCfgDataProperty.ChBox1Click(Sender: TObject);
begin
  with EditForm do
  begin
    if CheckBox1.Checked then
    begin
      Edit5.Enabled:= false;
      Button1.Enabled:= false;
    end
    else
    begin
      Edit5.Enabled:= true;
      Edit5.Text:= '<New password>';
      Edit5.SetFocus;
      Edit5.SelectAll;
    end;
  end;
end;

procedure TRegAppCfgDataProperty.Edit;
begin
  EditForm:= TfmRegAppCfgDataEdit.Create(Application);
  with EditForm do
  begin
    CheckBox1.OnClick:= ChBox1Click;
    Button1.OnClick:= Btn1Click;
    Button2.OnClick:= Btn2Click;
    Button3.OnClick:= Btn3Click;
    Edit5.OnChange:= Edit5Change;
    Show;
  end;
  GetValues;
end;

procedure TRegAppCfgDataProperty.Edit5Change(Sender: TObject);
begin
  with EditForm do
  begin
    if (Label6.Caption = 'Registry data found') and CheckBox2.Checked then
      TmRegApp(GetComponent(0)).ClearReg;
    Button1.Enabled:= (Edit5.Text <> '') and (Edit5.Text <> '<New password>');
  end;
end;

function TRegAppCfgDataProperty.GetAttributes: TPropertyAttributes;
begin
  result:= inherited GetAttributes + [paDialog];
end;

function TRegAppCfgDataProperty.GetValue: String;
begin
   result := '(Edit ConfigData)';
end;

procedure TRegAppCfgDataProperty.GetValues;
var
  dummy: TStringList;
  Str: string;
begin
  dummy:= TStringList.Create;
  try
    dummy.Text:= GetStrValue;
    with EditForm do
    begin
      Edit1.Text:= dummy[0];
      Edit2.Text:= dummy[1];
      Edit3.Text:= dummy[2];
      Str:= TmRegApp(GetComponent(0)).GetInstallKey;
      if Str = 'No data' then
      begin
        Edit4.Text:= '';
        Label6.Caption:= 'No registry data';
        CheckBox1.Checked:= false;
        Edit5.Enabled:= true;
        Edit5.Text:= '<New password>';
        Edit5.SetFocus;
        Edit5.SelectAll;
      end
      else
      begin
        Edit4.Text:= Str;
        Label6.Caption:= 'Registry data found';
        CheckBox1.Checked:= true;
        Edit5.Text:= dummy[5];
      end;
      CheckBox2.Checked:= dummy[6] = '1';
    end;
  finally
    dummy.Free;
  end;
end;

procedure TRegAppCfgDataProperty.SetValues;
var
  dummy: TStringList;
begin
  dummy:= TStringList.Create;
  try
    dummy.Clear;
    with EditForm do
    begin
      dummy.Add(Edit1.Text);
      dummy.Add(Edit2.Text);
      dummy.Add(Edit3.Text);
      dummy.Add(Edit4.Text);
      if CheckBox1.Checked then
        dummy.Add('1')
      else
        dummy.Add('0');
      dummy.Add(Edit5.Text);
      if CheckBox2.Checked then
        dummy.Add('1')
      else
        dummy.Add('0');
    end;
    SetStrValue(dummy.Text);
  finally
    dummy.Free;
  end;
end;

end.

