unit ExceptionListenerImpl;

interface

uses Windows, frausCommon, Dialogs;

type
	TPTExceptionListener = class(TInterfacedObject, IatExceptionListener)
   public
   	constructor Create();
      destructor  Destroy; override;

      // IatExceptionListener
      // this method will be executed when FailureAgent.dll was unloaded
      procedure OnFailureAgentUnloaded(); stdcall;
   	// some exception has been raised
   	function OnException ( const pException : IatException ) : HRESULT; stdcall;
		// unhandled exception occured
      function OnUnhandledException( const pException: IatException ) : HRESULT; stdcall;
		// the filter will generate memory dump, and want to get extended information to save in
      function OnDump( const pUserException : IatUserDumpStream ) : HRESULT; stdcall;
   end;

//Exported function declaration
function SetExceptionFilter(const EhFilter : IatExceptionfilter) : BOOL; stdcall;

implementation

// exported function implementation
function SetExceptionFilter(const EhFilter : IatExceptionfilter) : BOOL; stdcall;
var pListener : IatExceptionListener;
begin
   Result := false;
	Assert( EhFilter <> nil );
   if ( EhFilter = nil ) then
   	exit;
	pListener := TPTExceptionListener.Create as IatExceptionListener;
	EhFilter.RegisterExceptionListener(pListener);
   Result := true;
end;

{ TPTExceptionListener }
constructor TPTExceptionListener.Create;
begin
	Inherited;
end;

destructor TPTExceptionListener.Destroy;
begin
  inherited;
end;

function TPTExceptionListener.OnDump(const pUserException : IatUserDumpStream): HRESULT;
begin
   ShowMessage('OnDump method executed');
	result := S_FALSE;
end;

function TPTExceptionListener.OnException(
  const pException: IatException): HRESULT;
begin
   ShowMessage('OnException method executed');
	result := S_OK;
end;

function TPTExceptionListener.OnUnhandledException(
  const pException: IatException): HRESULT;
begin
   ShowMessage('OnEUnhandledxception method executed');
	result := S_OK;
end;

// this method will be executed when FailureAgent.dll was unloaded
procedure TPTExceptionListener.OnFailureAgentUnloaded(); stdcall;
begin
end;

end.
