// mfcuserdll.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "mfcuserdll.h"
#include "..\..\..\..\frausCommon.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CmfcuserdllApp
BEGIN_MESSAGE_MAP(CmfcuserdllApp, CWinApp)
END_MESSAGE_MAP()

// CmfcuserdllApp construction
CmfcuserdllApp::CmfcuserdllApp()
{
}

CmfcuserdllApp theApp;

BOOL CmfcuserdllApp::InitInstance()
{
	CWinApp::InitInstance();
	return TRUE;
}

IatExceptionfilter *gpExceptionFilter;

///////////////////////////////////////////////////////
// class CatExceptionListenerImpl : public IatExceptionListener
class CatExceptionListenerImpl : public IatExceptionListener
{
private:
	ULONG m_ulRefCnt;
public:
	CatExceptionListenerImpl();
	virtual ~CatExceptionListenerImpl();
	// Iunknown
	virtual HRESULT	__stdcall QueryInterface(REFIID iid, void ** ppvObject);
	virtual ULONG		__stdcall AddRef(void);
	virtual ULONG		__stdcall Release(void);
	// IatExceptionListener
	// this method will be executed when FailureAgent.dll was unloaded
	virtual void    __stdcall OnFailureAgentUnloaded(){};
	virtual HRESULT	__stdcall OnException(IatException * pException /*[in]*/);
	// unhandled exception occured
	virtual HRESULT __stdcall OnUnhandledException(IatException *pException);
	// the filter will generate memory dump, and want to get extended information to save in
	virtual HRESULT __stdcall OnDump( IatUserDumpStream* pUserDumpStream );
};

///////////////////////////////////////////////////////
// class CatExceptionListenerImpl : public IatExceptionListener
CatExceptionListenerImpl::CatExceptionListenerImpl()
{
	m_ulRefCnt = 0;
}

CatExceptionListenerImpl::~CatExceptionListenerImpl()
{
}

// Iunknown
HRESULT CatExceptionListenerImpl::QueryInterface(REFIID iid, void ** ppvObject)
{
	*ppvObject = (IatExceptionListener*)this;
	return S_OK;
}

ULONG CatExceptionListenerImpl::AddRef(void)
{
	return ++m_ulRefCnt;
}

ULONG CatExceptionListenerImpl::Release(void)
{
	--m_ulRefCnt;
	if ( m_ulRefCnt == 0 )
		delete this;
	return m_ulRefCnt;
}

// IatExceptionListener
HRESULT CatExceptionListenerImpl::OnException(IatException * pException /*[in]*/)
{
	MessageBox(NULL, _T("User Handler"), NULL, MB_OK);
	UINT_PTR addr = pException->GetEip();
	char buf[28];
	itoa(addr, buf, 16);
	MessageBox(NULL, buf, NULL, MB_OK);
	return S_OK;
}

// unhandled exception occured
HRESULT __stdcall CatExceptionListenerImpl::OnUnhandledException(IatException *pException)
{
	MessageBox(NULL, _T("User Unhandled Handler"), NULL, MB_OK);
	UINT_PTR addr = pException->GetEip();
	char buf[28];
	itoa(addr, buf, 16);
	MessageBox(NULL, buf, NULL, MB_OK);
	return S_OK;
}

// the filter will generate memory dump, and want to get extended information to save in
HRESULT __stdcall CatExceptionListenerImpl::OnDump( IatUserDumpStream* pUserDumpStream )
{
	MessageBox(NULL, _T("User OnDump handler"), NULL, MB_OK);
	return S_OK;
}

CatExceptionListenerImpl ExceptionListener;

extern "C" BOOL PASCAL EXPORT SetExceptionFilter(IatExceptionfilter *ExceptionFilter)
{
	gpExceptionFilter = ExceptionFilter;
	gpExceptionFilter->AddRef();
	gpExceptionFilter->RegisterExceptionListener(&ExceptionListener);
	return TRUE;
}
