unit ExceptionImpl;

interface

uses Windows, frausCommon, Dialogs;

type
TPTExceptionListener = class(TInterfacedObject, IatExceptionListener)
   public
   	constructor Create();
      destructor  Destroy; override;

      // IatExceptionListener
      procedure OnFailureAgentUnloaded(); stdcall;
   	// some exception has been raised
   	function OnException ( const pException : IatException ) : HRESULT; stdcall;
		// unhandled exception occured
      function OnUnhandledException( const pException: IatException ) : HRESULT; stdcall;
		// the filter will generate memory dump, and want to get extended information to save in
      function OnDump( const pUserException : IatUserDumpStream ) : HRESULT; stdcall;
   end;

implementation

{ TPTExceptionListener }
constructor TPTExceptionListener.Create;
begin
	Inherited;
end;

destructor TPTExceptionListener.Destroy;
begin
  inherited;
end;

function TPTExceptionListener.OnDump(const pUserException : IatUserDumpStream ): HRESULT;
begin
   ShowMessage('OnDump method executed');
	result := S_FALSE;
end;

function TPTExceptionListener.OnException(
  const pException: IatException): HRESULT;
begin
   ShowMessage('OnException method executed');
	result := S_OK;
end;

function TPTExceptionListener.OnUnhandledException(
  const pException: IatException): HRESULT;
begin
   ShowMessage('OnEUnhandledxception method executed');
	result := S_OK;
end;

procedure TPTExceptionListener.OnFailureAgentUnloaded(); stdcall;
begin
end;

end.
