unit UserDllModule;

interface

uses windows, frausCommon;

type
	TUserDllModule = class
   private
      FExceptionListener : IatExceptionListener;
   public
   	constructor Create;
      destructor  Destroy; override;
   end;

implementation

uses ExceptionImpl, sysutils;

var userDll : TUserDllModule;

constructor TUserDllModule.Create;
var hFailureAgent      : THandle;
var GetExceptionFilter : TGetExceptionFilter;
var ExceptionFilter    : IatExceptionfilter;
begin
	hFailureAgent := GetModuleHandle(FAILUREAGENTDLLNAME);
   if ( hFailureAgent <> 0 ) then
   begin
   	GetExceptionFilter := GetProcAddress(hFailureAgent, GETEXCEPTIONFILTERNAME);
      if ( @GetExceptionFilter <> nil ) then
	      GetExceptionFilter( ExceptionFilter );
      if ( ExceptionFilter <> nil ) then
      begin
      	FExceptionListener := TPTExceptionListener.Create() as IatExceptionListener;
      	ExceptionFilter.registerExceptionListener(FExceptionListener);
      end;
   end;
	inherited;
end;

destructor  TUserDllModule.Destroy;
begin
	FExceptionListener := nil;
	inherited;
end;

initialization
	userDll := TUserDllModule.Create;
finalization
	FreeAndNil(userDll);
end.
