// MFCtestDlg.cpp : @
//

#include "stdafx.h"
#include "MFCtest.h"
#include "MFCtestDlg.h"
#include ".\mfctestdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

const _TCHAR CErrFrausDidnotReturnFilter[] = _T("Cold not get Exception Filter");
const _TCHAR CErrCannotResolveExceptionFilter[] = _T("Cold not resolve GetExceptionFilter function");
const _TCHAR CErrCannnotLoadFraus[] = _T("Cannot load FailureAgent.dll");
const _TCHAR CErrLibraryIsLoaded[] = _T("The failureAgent.dll is already lodaded. Cant load it twice");
const _TCHAR FrausBase[] = _T("FailureAgent.dll");

///////////////////////////////////////////////////////
// class CatExceptionListenerImpl : public IatExceptionListener
CatExceptionListenerImpl::CatExceptionListenerImpl(CMFCtestDlg *pApplication)
{
	m_ulRefCnt     = 0;
	m_pApplication = pApplication;
}

CatExceptionListenerImpl::~CatExceptionListenerImpl()
{
}

// Iunknown
HRESULT CatExceptionListenerImpl::QueryInterface(REFIID iid, void ** ppvObject)
{
	*ppvObject = (IatExceptionListener*)this;
	return S_OK;
}

ULONG CatExceptionListenerImpl::AddRef(void)
{
	return ++m_ulRefCnt;
}

ULONG CatExceptionListenerImpl::Release(void)
{
	--m_ulRefCnt;
	if ( m_ulRefCnt == 0 )
		delete this;
	return m_ulRefCnt;
}

// IatExceptionListener
// this method will be executed when FailureAgent.dll was unloaded
void __stdcall CatExceptionListenerImpl::OnFailureAgentUnloaded()
{
	m_pApplication->FailureAgentUnloaded();
}

HRESULT CatExceptionListenerImpl::OnException(IatException * pException /*[in]*/)
{
	MessageBox(NULL, _T("User Handler"), NULL, MB_OK);
	UINT_PTR addr = pException->GetEip();
	char buf[28];
	itoa((int)addr, buf, 16);
	MessageBox(NULL, buf, NULL, MB_OK);
	return S_OK;
}

// unhandled exception occured
HRESULT __stdcall CatExceptionListenerImpl::OnUnhandledException(IatException *pException)
{
	MessageBox(NULL, _T("User Unhandled Handler"), NULL, MB_OK);
	UINT_PTR addr = pException->GetEip();
	char buf[28];
	itoa((int)addr, buf, 16);
	MessageBox(NULL, buf, NULL, MB_OK);
	return S_OK;
}

// the filter will generate memory dump, and want to get extended information to save in
HRESULT __stdcall CatExceptionListenerImpl::OnDump( IatUserDumpStreamWriter *pUserDumpStream )
{
	MessageBox(NULL, _T("User OnDump handler"), NULL, MB_OK);
	return S_OK;
}

//////////////////////////////////////////////////////
//
CMFCtestDlg::CMFCtestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFCtestDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CMFCtestDlg::~CMFCtestDlg()
{
	OnBnClickedUnreghandler();
}

void CMFCtestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMFCtestDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDB_LOAD, OnBnClickedLoad)
	ON_BN_CLICKED(IDB_UNLOAD, OnBnClickedUnload)
	ON_BN_CLICKED(IDB_APPLY, OnBnClickedApply)
	ON_BN_CLICKED(IDB_REGHANDLER, OnBnClickedReghandler)
	ON_BN_CLICKED(IDB_UNREGHANDLER, OnBnClickedUnreghandler)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDB_AV, OnBnClickedAv)
	ON_BN_CLICKED(IDB_MATH, OnBnClickedMath)
	ON_BN_CLICKED(IDB_USER, OnBnClickedUser)
	ON_BN_CLICKED(IDB_HAV, OnBnClickedHav)
	ON_BN_CLICKED(IDB_HMATH, OnBnClickedHmath)
	ON_BN_CLICKED(IDB_HUSER, OnBnClickedHuser)
	ON_BN_CLICKED(IDB_SKIPAV, OnBnClickedSkipav)
	ON_BN_CLICKED(IDB_SKIPMATH, OnBnClickedSkipmath)
	ON_BN_CLICKED(IDB_SKIPUSER, OnBnClickedSkipuser)
	ON_BN_CLICKED(IDB_RESTOREAV, OnBnClickedRestoreav)
	ON_BN_CLICKED(IDB_RESTOREMATH, OnBnClickedRestoremath)
	ON_BN_CLICKED(IDB_RESTOREUSER, OnBnClickedRestoreuser)
END_MESSAGE_MAP()

BOOL CMFCtestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
	m_Module   = NULL;
	m_pFilter  = NULL;
	m_boLoaded = false;
	m_Listener = NULL;
	changeState(m_boLoaded);
	return TRUE;
}

void CMFCtestDlg::cleanListener()
{
	m_pFilter  = NULL;
	m_boLoaded = false;
	//if ( m_Listener )
	//	m_Listener->Release();
	m_Listener = NULL;
	m_Module   = NULL;
}

void CMFCtestDlg::FailureAgentUnloaded()
{
	if ( m_Listener ) {
		cleanListener();
		changeState(m_boLoaded);
	}
}

void CMFCtestDlg::changeState(bool bNewState)
{
	changeItemState(GetDlgItem(IDB_MAKELOG), bNewState);
	changeItemState(GetDlgItem(IDB_SKIPAV), bNewState);
	changeItemState(GetDlgItem(IDB_SKIPMATH), bNewState);
	changeItemState(GetDlgItem(IDB_SKIPUSER), bNewState);
	changeItemState(GetDlgItem(IDB_RESTOREAV), bNewState);
	changeItemState(GetDlgItem(IDB_RESTOREMATH), bNewState);
	changeItemState(GetDlgItem(IDB_RESTOREUSER), bNewState);
	changeItemState(GetDlgItem(IDB_USEDLL), bNewState);
	changeItemState(GetDlgItem(IDB_FAILONEXCEPT), bNewState);
	changeItemState(GetDlgItem(IDB_REGHANDLER), bNewState);
	changeItemState(GetDlgItem(IDB_UNREGHANDLER), bNewState);
	changeItemState(GetDlgItem(IDB_APPLY), bNewState);
	changeItemState(GetDlgItem(IDB_UNLOAD), bNewState);
	changeItemState(GetDlgItem(IDB_GROUP), bNewState);
	changeItemState(GetDlgItem(IDB_LOAD), !bNewState);
}

void CMFCtestDlg::readSettings()
{
	assert(m_pFilter); if ( m_pFilter == NULL ) return;
	LONG settings = m_pFilter->GetCurrentSettings();
	CheckDlgButton(IDB_MAKELOG, (settings & SV_MAKELOG) ? BST_CHECKED : BST_UNCHECKED );
	CheckDlgButton(IDB_USEDLL, (settings & SV_MAKELOG) ? BST_CHECKED : BST_UNCHECKED );
	CheckDlgButton(IDB_FAILONEXCEPT, (settings & SV_FAILONEXCEPT) ? BST_CHECKED : BST_UNCHECKED );
}

void CMFCtestDlg::OnPaint() 
{
	if ( ! IsIconic() )
		CDialog::OnPaint();
	else
	{
		CPaintDC dc(this);
		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		dc.DrawIcon(x, y, m_hIcon);
	}
}

HCURSOR CMFCtestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void avFunction()
{
	__asm mov eax, 0
	__asm mov [eax], 123
}

void mathEhFunction()
{
	__asm mov eax, 0
	__asm div eax
}

void userEhFunction()
{
	throw(123);
}

void CMFCtestDlg::OnBnClickedLoad()
{
	if ( m_Module != NULL ){
		MessageBox(CErrLibraryIsLoaded);
		return;
	}
	m_Module = LoadLibrary(FrausBase);
	if ( ! m_Module ) {
		MessageBox(CErrCannnotLoadFraus);
		return;
	}

	m_lpfnGetExceptionFilter = (TGetExceptionFilter)
		GetProcAddress(m_Module, "GetExceptionFilter");
	if ( m_lpfnGetExceptionFilter == NULL ) {
		MessageBox(CErrCannotResolveExceptionFilter);
		return;
	}
	if ( S_OK != m_lpfnGetExceptionFilter(&m_pFilter) ) {
		MessageBox(CErrFrausDidnotReturnFilter);
		return;
	}
	m_boLoaded = true;
	readSettings();
	changeState(m_boLoaded);
}

void CMFCtestDlg::OnBnClickedUnload()
{
	if ( m_Module != NULL ) {
		OnBnClickedUnreghandler();
		m_pFilter->Release();
		m_lpfnGetExceptionFilter = NULL;
		m_boLoaded = false;
		FreeLibrary(m_Module);
		m_Module = NULL;
		changeState(m_boLoaded);
	}
}

void CMFCtestDlg::OnBnClickedApply()
{
	assert(m_pFilter); if ( m_pFilter == NULL ) return;
	LONG settings;
	if ( IsDlgButtonChecked(IDB_MAKELOG) ) 
		settings |= SV_MAKELOG;
	if ( IsDlgButtonChecked(IDB_USEDLL) ) 
		settings |= 0;
	if ( IsDlgButtonChecked(IDB_FAILONEXCEPT) ) 
		settings |= SV_FAILONEXCEPT;

	m_pFilter->OverrideSettings(settings);
}

void CMFCtestDlg::OnBnClickedReghandler()
{
	assert(m_pFilter); if ( m_pFilter == NULL ) return;

	m_Listener = (IatExceptionListener *)new CatExceptionListenerImpl(this);
	assert(m_Listener); if ( m_Listener == NULL ) return;

	m_Listener->AddRef();
	m_pFilter->RegisterExceptionListener(m_Listener);
}

void CMFCtestDlg::OnBnClickedUnreghandler()
{
	if ( m_Listener ) {
		if ( m_pFilter )
			m_pFilter->UnregisterExceptionListener( m_Listener );
		m_Listener->Release();
		m_Listener = NULL;
	}
}

void CMFCtestDlg::OnDestroy()
{
	CDialog::OnDestroy();
}

void CMFCtestDlg::OnBnClickedAv()
{
	avFunction();
}

void CMFCtestDlg::OnBnClickedMath()
{
	mathEhFunction();
}

void CMFCtestDlg::OnBnClickedUser()
{
	throw(123);
}

void CMFCtestDlg::OnBnClickedHav()
{
	try{
		OnBnClickedAv();
	}
	catch(...) {
	}
}

void CMFCtestDlg::OnBnClickedHmath()
{
	try {
		OnBnClickedMath();
	}
	catch(...) {
	}
}

void CMFCtestDlg::OnBnClickedHuser()
{
	try {
		OnBnClickedUser();
	}
	catch(...) {
	}
}

void CMFCtestDlg::OnBnClickedSkipav()
{
	assert(m_pFilter);
	if ( m_pFilter )
		m_pFilter->AddSafeException(0xC0000005);
}

void CMFCtestDlg::OnBnClickedSkipmath()
{
	assert(m_pFilter);
	if ( m_pFilter )
		m_pFilter->AddSafeException(0xC0000094);
}

void CMFCtestDlg::OnBnClickedSkipuser()
{
	assert(m_pFilter);
	if ( m_pFilter )
		m_pFilter->AddSafeException(123);
}

void CMFCtestDlg::OnBnClickedRestoreav()
{
	assert(m_pFilter);
	if ( m_pFilter )
		m_pFilter->DeleteSafeExceptionCode(0xC0000005);
}

void CMFCtestDlg::OnBnClickedRestoremath()
{
	assert(m_pFilter);
	if ( m_pFilter )
		m_pFilter->DeleteSafeExceptionCode(0xC0000094);
}

void CMFCtestDlg::OnBnClickedRestoreuser()
{
	assert(m_pFilter);
	if ( m_pFilter )
		m_pFilter->DeleteSafeExceptionCode(123);
}
