// MFCtestDlg.h
//

#pragma once
#include "afxwin.h"

#include <assert.h>
#include "..\..\..\..\frausCommon.h"

class CMFCtestDlg;

///////////////////////////////////////////////////////
// class CatExceptionListenerImpl : public IatExceptionListener
class CatExceptionListenerImpl : public IatExceptionListener
{
private:
	ULONG       m_ulRefCnt;
	CMFCtestDlg *m_pApplication;
public:
	CatExceptionListenerImpl(CMFCtestDlg *pApplication);
	virtual ~CatExceptionListenerImpl();
	// Iunknown
	virtual HRESULT	__stdcall QueryInterface(REFIID iid, void ** ppvObject);
	virtual ULONG		__stdcall AddRef(void);
	virtual ULONG		__stdcall Release(void);
	// this method will be executed when FailureAgent.dll was unloaded
	virtual void    __stdcall OnFailureAgentUnloaded();
	// IatExceptionListener
	virtual HRESULT	__stdcall OnException(IatException * pException /*[in]*/);
	// unhandled exception occured
	virtual HRESULT __stdcall OnUnhandledException(IatException *pException);
	// the filter will generate memory dump, and want to get extended information to save in
	virtual HRESULT __stdcall OnDump( IatUserDumpStreamWriter * pUserDumpStream);
};

//////////////////////////////////////////////////////
// class CMFCtestDlg : public CDialog
class CMFCtestDlg : public CDialog
{
	TGetExceptionFilter			m_lpfnGetExceptionFilter;
	IatExceptionfilter			*m_pFilter;
	IatExceptionListener    	*m_Listener;
	HMODULE						   m_Module;
	bool                       m_boLoaded;
public:
	CMFCtestDlg(CWnd* pParent = NULL);
	virtual ~CMFCtestDlg();
	void cleanListener();
	void FailureAgentUnloaded();
	enum { IDD = IDD_MFCTEST_DIALOG };

protected:
	void changeItemState( CWnd* pWnd, bool bNewState)
	{
		assert(pWnd); if ( pWnd == NULL ) return ;
		pWnd->EnableWindow( bNewState == true );
	}
	void readSettings();
	void changeState(bool bNewState);
	virtual void DoDataExchange(CDataExchange* pDX);

	HICON m_hIcon;
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedLoad();
	afx_msg void OnBnClickedUnload();
	afx_msg void OnBnClickedApply();
	afx_msg void OnBnClickedReghandler();
	afx_msg void OnBnClickedUnreghandler();
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedAv();
	afx_msg void OnBnClickedMath();
	afx_msg void OnBnClickedUser();
	afx_msg void OnBnClickedHav();
	afx_msg void OnBnClickedHmath();
	afx_msg void OnBnClickedHuser();
	afx_msg void OnBnClickedSkipav();
	afx_msg void OnBnClickedSkipmath();
	afx_msg void OnBnClickedSkipuser();
	afx_msg void OnBnClickedRestoreav();
	afx_msg void OnBnClickedRestoremath();
	afx_msg void OnBnClickedRestoreuser();
};
