// UserEhFilter.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "UserEhFilter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

BEGIN_MESSAGE_MAP(CUserEhFilterApp, CWinApp)
END_MESSAGE_MAP()

CUserEhFilterApp   theApp;
bool               gboFailureAgentActive;

CUserEhFilterApp::CUserEhFilterApp()
{
	m_pEhListener          = NULL;
	m_lpGetExceptionFilter = NULL;
}

CUserEhFilterApp::~CUserEhFilterApp()
{
	if ( ( m_lpGetExceptionFilter ) && ( gboFailureAgentActive ) ) {
		IatExceptionfilter *pFilter = NULL;
		m_lpGetExceptionFilter(&pFilter);
		if ( pFilter ) {
			pFilter->UnregisterExceptionListener(m_pEhListener);
			pFilter->Release();
		}
	}

	if ( m_pEhListener )
		m_pEhListener->Release();
}

BOOL CUserEhFilterApp::InitInstance()
{
	gboFailureAgentActive = true; // we initialized this variable tu true, because FailureAgent loaded this dll
	MessageBox(NULL, "Exception filter in User DLL was loaded", "UserEhFilter.dll", MB_OK);
	CWinApp::InitInstance();
	m_pEhListener = new CUserEhListenerImpl();
	m_pEhListener->AddRef();

	HMODULE hModule  = GetModuleHandle("failureagent.dll");
	assert(hModule);
	if ( hModule ) {
		m_lpGetExceptionFilter = (TGetExceptionFilter)GetProcAddress(hModule, "GetExceptionFilter");
		if ( m_lpGetExceptionFilter ) {
			IatExceptionfilter *pFilter = NULL;
			m_lpGetExceptionFilter(&pFilter);
			if ( pFilter ) {
				pFilter->RegisterExceptionListener(m_pEhListener);
				pFilter->Release();
			}
		}
	}
	return TRUE;
}

IatExceptionListener* CUserEhFilterApp::getExceptionListener()
{
	if ( m_pEhListener )
		m_pEhListener->AddRef();
	return m_pEhListener;
}

////////////////////////////////////////////////////////////
//
CUserEhListenerImpl::CUserEhListenerImpl()
{
	m_ulRefCount = 0;
}

CUserEhListenerImpl::~CUserEhListenerImpl()
{
}

// IatExceptionListener
void __stdcall CUserEhListenerImpl::OnFailureAgentUnloaded()
{
	gboFailureAgentActive = false;
}

// some exception has been raised
HRESULT __stdcall CUserEhListenerImpl::OnException(IatException * pException /*[in]*/)
{
	MessageBox(NULL, "In DLL handler", "OnException", MB_OK);
	return S_OK;
}

// unhandled exception occured
HRESULT __stdcall CUserEhListenerImpl::OnUnhandledException(IatException *pException)
{
	MessageBox(NULL, "In DLL handler", "OnUnhandledException", MB_OK);
	return S_OK;
}

// the filter will generate memory dump, and want to get extended information to save in
HRESULT __stdcall CUserEhListenerImpl::OnDump( IatUserDumpStream* pUserDumpStream)
{
	MessageBox(NULL, "In DLL handler", "OnDump", MB_OK);
	return S_OK;
}