// UserEhFilter.h : main header file for the UserEhFilter DLL
//

#pragma once

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include <assert.h>

#include "resource.h"		// main symbols
#include "..\..\..\..\frausCommon.h"

// CUserEhFilterApp
// See UserEhFilter.cpp for the implementation of this class
class CUserEhFilterApp : public CWinApp
{
private:
	IatExceptionListener *m_pEhListener;
	TGetExceptionFilter  m_lpGetExceptionFilter;
public:
	CUserEhFilterApp();
	virtual ~CUserEhFilterApp();

	virtual BOOL InitInstance();

	IatExceptionListener* getExceptionListener();
	DECLARE_MESSAGE_MAP()
};

class CUserEhListenerImpl : public IatExceptionListener
{
	ULONG m_ulRefCount;
public:
	CUserEhListenerImpl();
	virtual ~CUserEhListenerImpl();

	virtual ULONG __stdcall AddRef(void)
	{
		return ::InterlockedIncrement((LONG*)&m_ulRefCount);
	}

	virtual ULONG __stdcall Release(void)
	{
		::InterlockedDecrement((LONG*)&m_ulRefCount);
		if ( ! m_ulRefCount ) {
			delete this;
			return 0;
		}
		return m_ulRefCount;
	}

	virtual HRESULT __stdcall QueryInterface(REFIID iid, void **ppvObject)
	{
		assert(ppvObject);
		if ( ppvObject == NULL ) return S_FALSE;
		if ( IID_IUnknown == iid ) {
			AddRef();
			*ppvObject = this;
			return S_OK;
		}
		else if ( IID_IatExceptionListener == iid ) {
			AddRef();
			*ppvObject = this;
			return S_OK;
		}
		return S_FALSE;
	}
	// IatExceptionListener
	// this method will be executed when FailureAgent.dll was unloaded
	virtual void    __stdcall OnFailureAgentUnloaded();
	// some exception has been raised
	virtual HRESULT __stdcall OnException(IatException * pException /*[in]*/);
	// unhandled exception occured
	virtual HRESULT __stdcall OnUnhandledException(IatException *pException);
	// the filter will generate memory dump, and want to get extended information to save in
	virtual HRESULT __stdcall OnDump( IatUserDumpStream* pUserDumpStream);
};